diff -ruN vdr-1.7.9/dvbspu.c vdr-1.7.10/dvbspu.c
--- vdr-1.7.9/dvbspu.c	2009-05-09 18:25:59.000000000 +0200
+++ vdr-1.7.10/dvbspu.c	2009-11-22 15:17:59.000000000 +0100
@@ -8,7 +8,7 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.c 2.1 2009/05/09 16:25:59 kls Exp $
+ * $Id: dvbspu.c 2.2 2009/11/22 14:17:59 kls Exp $
  */
 
 #include "dvbspu.h"
@@ -55,6 +55,9 @@
 #define setMin(a, b) if (a > b) a = b
 #define setMax(a, b) if (a < b) a = b
 
+#define spuXres   720
+#define spuYres   576
+
 #define revRect(r1, r2) { r1.x1 = r2.x2; r1.y1 = r2.y2; r1.x2 = r2.x1; r1.y2 = r2.y1; }
 
 cDvbSpuBitmap::cDvbSpuBitmap(sDvbSpuRect size,
@@ -63,8 +66,8 @@
 {
     size.x1 = max(size.x1, 0);
     size.y1 = max(size.y1, 0);
-    size.x2 = min(size.x2, Setup.OSDWidth);
-    size.y2 = min(size.y2, Setup.OSDHeight);
+    size.x2 = min(size.x2, spuXres - 1);
+    size.y2 = min(size.y2, spuYres - 1);
 
     bmpsize = size;
     revRect(minsize[0], size);
@@ -72,7 +75,7 @@
     revRect(minsize[2], size);
     revRect(minsize[3], size);
 
-    int MemSize = bmpsize.width() * bmpsize.height() * sizeof(uint8_t);
+    int MemSize = spuXres * spuYres * sizeof(uint8_t);
     bmp = new uint8_t[MemSize];
 
     if (bmp)
@@ -93,10 +96,10 @@
     int h = size.height();
     int w = size.width();
 
-    if (size.y1 + h >= bmpsize.height())
-        h = bmpsize.height() - size.y1 - 1;
-    if (size.x1 + w >= bmpsize.width())
-        w = bmpsize.width() - size.x1 - 1;
+    if (size.y1 + h >= spuYres)
+        h = spuYres - size.y1 - 1;
+    if (size.x1 + w >= spuXres)
+        w = spuXres - size.x1 - 1;
 
     if (w & 0x03)
         w += 4 - (w & 0x03);
@@ -111,11 +114,13 @@
     }
 
     // set the content
-    for (int yp = 0; yp < h; yp++) {
-        for (int xp = 0; xp < w; xp++) {
-            uint8_t idx = bmp[(size.y1 + yp) * bmpsize.width() + size.x1 + xp];
-            ret->SetIndex(xp, yp, idx);
-        }
+    if (bmp) {
+       for (int yp = 0; yp < h; yp++) {
+           for (int xp = 0; xp < w; xp++) {
+               uint8_t idx = bmp[(size.y1 + yp) * spuXres + size.x1 + xp];
+               ret->SetIndex(xp, yp, idx);
+           }
+       }
     }
     return ret;
 }
@@ -149,7 +154,8 @@
 
 void cDvbSpuBitmap::putPixel(int xp, int yp, int len, uint8_t colorid)
 {
-    memset(bmp + bmpsize.width() * yp + xp, colorid, len);
+    if (bmp)
+       memset(bmp + spuXres * yp + xp, colorid, len);
     setMin(minsize[colorid].x1, xp);
     setMin(minsize[colorid].y1, yp);
     setMax(minsize[colorid].x2, xp + len - 1);
diff -ruN vdr-1.7.9/dvbsubtitle.c vdr-1.7.10/dvbsubtitle.c
--- vdr-1.7.9/dvbsubtitle.c	2008-05-25 16:36:24.000000000 +0200
+++ vdr-1.7.10/dvbsubtitle.c	2009-11-22 13:28:53.000000000 +0100
@@ -7,7 +7,7 @@
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 2.1 2008/05/25 14:36:24 kls Exp $
+ * $Id: dvbsubtitle.c 2.2 2009/11/22 12:28:53 kls Exp $
  */
 
 #include "dvbsubtitle.h"
@@ -699,7 +699,7 @@
         }
 
      if (Length > PayloadOffset + SubstreamHeaderLength) {
-        int64_t pts = PesGetPts(Data);
+        int64_t pts = PesHasPts(Data) ? PesGetPts(Data) : 0;
         if (pts)
            dbgconverter("Converter PTS: %lld\n", pts);
         const uchar *data = Data + PayloadOffset + SubstreamHeaderLength; // skip substream header
diff -ruN vdr-1.7.9/i18n-to-gettext.pl vdr-1.7.10/i18n-to-gettext.pl
--- vdr-1.7.9/i18n-to-gettext.pl	2007-11-04 11:57:36.000000000 +0100
+++ vdr-1.7.10/i18n-to-gettext.pl	2009-10-18 16:07:49.000000000 +0200
@@ -10,7 +10,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: i18n-to-gettext.pl 2.0 2007/11/04 10:57:36 kls Exp $
+# $Id: i18n-to-gettext.pl 2.1 2009/10/18 14:07:49 kls Exp $
 
 # How to convert an actual plugin:
 #
@@ -87,7 +87,7 @@
 # Plugin specific information:
 
 $TITLE = "VDR plugin language source file";
-$COPYRIGHT = "2007 Klaus Schmidinger <kls\@cadsoft.de>";
+$COPYRIGHT = "2007 Klaus Schmidinger <kls\@tvdr.de>";
 $PACKAGE = "VDR";
 $VERSION = "1.5.7";
 $MSGIDBUGS = "" || die "enter your email address here"; # escape the '@', as in "user\@domain.tld"
@@ -152,8 +152,8 @@
   );
 
 @TRANSLATORS = (
-  "Klaus Schmidinger <kls\@cadsoft.de>, 2000",
-  "Klaus Schmidinger <kls\@cadsoft.de>, 2000",
+  "Klaus Schmidinger <kls\@tvdr.de>, 2000",
+  "Klaus Schmidinger <kls\@tvdr.de>, 2000",
   "Miha Setina <mihasetina\@softhome.net>, 2000; Matjaz Thaler <matjaz.thaler\@guest.arnes.si>, 2003",
   "Alberto Carraro <bertocar\@tin.it>, 2001; Antonio Ospite <ospite\@studenti.unina.it>, 2003; Sean Carlos <seanc\@libero.it>, 2005",
   "Arnold Niessen <niessen\@iae.nl> <arnold.niessen\@philips.com>, 2001; Hans Dingemans <hans.dingemans\@tacticalops.nl>, 2003; Maarten Wisse <Maarten.Wisse\@urz.uni-hd.de>, 2005",
@@ -177,8 +177,8 @@
   );
 
 @LASTTRANSLATOR = (
-  "Klaus Schmidinger <kls\@cadsoft.de>",
-  "Klaus Schmidinger <kls\@cadsoft.de>",
+  "Klaus Schmidinger <kls\@tvdr.de>",
+  "Klaus Schmidinger <kls\@tvdr.de>",
   "Matjaz Thaler <matjaz.thaler\@guest.arnes.si>",
   "Sean Carlos <seanc\@libero.it>",
   "Maarten Wisse <Maarten.Wisse\@urz.uni-hd.de>",
diff -ruN vdr-1.7.9/recorder.c vdr-1.7.10/recorder.c
--- vdr-1.7.9/recorder.c	2009-05-23 14:18:25.000000000 +0200
+++ vdr-1.7.10/recorder.c	2009-11-21 16:58:12.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 2.4 2009/05/23 12:18:25 kls Exp $
+ * $Id: recorder.c 2.6 2009/11/21 15:58:12 kls Exp $
  */
 
 #include "recorder.h"
@@ -30,7 +30,7 @@
 
   SpinUpDisk(FileName);
 
-  ringBuffer = new cRingBufferLinear(RECORDERBUFSIZE, TS_SIZE * 2, true, "Recorder");
+  ringBuffer = new cRingBufferLinear(RECORDERBUFSIZE, MIN_TS_PACKETS_FOR_FRAME_DETECTOR * TS_SIZE, true, "Recorder");
   ringBuffer->SetTimeouts(0, 100);
   cChannel *Channel = Channels.GetByChannelID(ChannelID);
   int Pid = VPid;
@@ -116,6 +116,7 @@
 {
   time_t t = time(NULL);
   bool InfoWritten = false;
+  bool FirstIframeSeen = false;
   while (Running()) {
         int r;
         uchar *b = ringBuffer->Get(r);
@@ -134,25 +135,28 @@
                        }
                     InfoWritten = true;
                     }
-                 if (!NextFile())
-                    break;
-                 if (index && frameDetector->NewFrame())
-                    index->Write(frameDetector->IndependentFrame(), fileName->Number(), fileSize);
-                 if (frameDetector->IndependentFrame()) {
-                    recordFile->Write(patPmtGenerator.GetPat(), TS_SIZE);
-                    fileSize += TS_SIZE;
-                    int Index = 0;
-                    while (uchar *pmt = patPmtGenerator.GetPmt(Index)) {
-                          recordFile->Write(pmt, TS_SIZE);
-                          fileSize += TS_SIZE;
-                          }
-                    }
-                 if (recordFile->Write(b, Count) < 0) {
-                    LOG_ERROR_STR(fileName->Name());
-                    break;
+                 if (FirstIframeSeen || frameDetector->IndependentFrame()) {
+                    FirstIframeSeen = true; // start recording with the first I-frame
+                    if (!NextFile())
+                       break;
+                    if (index && frameDetector->NewFrame())
+                       index->Write(frameDetector->IndependentFrame(), fileName->Number(), fileSize);
+                    if (frameDetector->IndependentFrame()) {
+                       recordFile->Write(patPmtGenerator.GetPat(), TS_SIZE);
+                       fileSize += TS_SIZE;
+                       int Index = 0;
+                       while (uchar *pmt = patPmtGenerator.GetPmt(Index)) {
+                             recordFile->Write(pmt, TS_SIZE);
+                             fileSize += TS_SIZE;
+                             }
+                       }
+                    if (recordFile->Write(b, Count) < 0) {
+                       LOG_ERROR_STR(fileName->Name());
+                       break;
+                       }
+                    fileSize += Count;
+                    t = time(NULL);
                     }
-                 fileSize += Count;
-                 t = time(NULL);
                  }
               ringBuffer->Del(Count);
               }
diff -ruN vdr-1.7.9/recording.c vdr-1.7.10/recording.c
--- vdr-1.7.9/recording.c	2009-08-16 12:39:43.000000000 +0200
+++ vdr-1.7.10/recording.c	2009-11-22 12:20:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.17 2009/08/16 10:39:43 kls Exp $
+ * $Id: recording.c 2.18 2009/11/22 11:20:53 kls Exp $
  */
 
 #include "recording.h"
@@ -21,6 +21,7 @@
 #include "i18n.h"
 #include "interface.h"
 #include "remux.h"
+#include "ringbuffer.h"
 #include "skins.h"
 #include "tools.h"
 #include "videodir.h"
@@ -1309,6 +1310,124 @@
      }
 }
 
+// --- cIndexFileGenerator ---------------------------------------------------
+
+#define IFG_BUFFER_SIZE KILOBYTE(100)
+
+class cIndexFileGenerator : public cThread {
+private:
+  cString recordingName;
+protected:
+  virtual void Action(void);
+public:
+  cIndexFileGenerator(const char *RecordingName);
+  ~cIndexFileGenerator();
+  };
+
+cIndexFileGenerator::cIndexFileGenerator(const char *RecordingName)
+:cThread("index file generator")
+,recordingName(RecordingName)
+{
+  Start();
+}
+
+cIndexFileGenerator::~cIndexFileGenerator()
+{
+  Cancel(3);
+}
+
+void cIndexFileGenerator::Action(void)
+{
+  bool IndexFileComplete = false;
+  bool Rewind = false;
+  cFileName FileName(recordingName, false);
+  cUnbufferedFile *ReplayFile = FileName.Open();
+  cRingBufferLinear Buffer(IFG_BUFFER_SIZE, MIN_TS_PACKETS_FOR_FRAME_DETECTOR * TS_SIZE);
+  cPatPmtParser PatPmtParser;
+  cFrameDetector FrameDetector;
+  cIndexFile IndexFile(recordingName, true);
+  int BufferChunks = KILOBYTE(1); // no need to read a lot at the beginning when parsing PAT/PMT
+  off_t FileSize = 0;
+  off_t FrameOffset = -1;
+  Skins.QueueMessage(mtInfo, tr("Regenerating index file"));
+  while (Running()) {
+        // Rewind input file:
+        if (Rewind) {
+           ReplayFile = FileName.SetOffset(1);
+           Buffer.Clear();
+           Rewind = false;
+           }
+        // Process data:
+        int Length;
+        uchar *Data = Buffer.Get(Length);
+        if (Data) {
+           if (FrameDetector.Synced()) {
+              // Step 3 - generate the index:
+              if (TsPid(Data) == PATPID)
+                 FrameOffset = FileSize; // the PAT/PMT is at the beginning of an I-frame
+              int Processed = FrameDetector.Analyze(Data, Length);
+              if (Processed > 0) {
+                 if (FrameDetector.NewFrame()) {
+                    IndexFile.Write(FrameDetector.IndependentFrame(), FileName.Number(), FrameOffset >= 0 ? FrameOffset : FileSize);
+                    FrameOffset = -1;
+                    }
+                 FileSize += Processed;
+                 Buffer.Del(Processed);
+                 }
+              }
+           else if (PatPmtParser.Vpid()) {
+              // Step 2 - sync FrameDetector:
+              int Processed = FrameDetector.Analyze(Data, Length);
+              if (Processed > 0) {
+                 if (FrameDetector.Synced()) {
+                    // Synced FrameDetector, so rewind for actual processing:
+                    FrameDetector.Reset();
+                    Rewind = true;
+                    }
+                 Buffer.Del(Processed);
+                 }
+              }
+           else {
+              // Step 1 - parse PAT/PMT:
+              uchar *p = Data;
+              while (Length >= TS_SIZE) {
+                    int Pid = TsPid(p);
+                    if (Pid == 0)
+                       PatPmtParser.ParsePat(p, TS_SIZE);
+                    else if (Pid == PatPmtParser.PmtPid())
+                       PatPmtParser.ParsePmt(p, TS_SIZE);
+                    Length -= TS_SIZE;
+                    p += TS_SIZE;
+                    if (PatPmtParser.Vpid()) {
+                       // Found Vpid, so rewind to sync FrameDetector:
+                       FrameDetector.SetPid(PatPmtParser.Vpid(), PatPmtParser.Vtype());
+                       BufferChunks = IFG_BUFFER_SIZE;
+                       Rewind = true;
+                       break;
+                       }
+                    }
+              Buffer.Del(p - Data);
+              }
+           }
+        // Read data:
+        else if (ReplayFile) {
+           int Result = Buffer.Read(ReplayFile, BufferChunks);
+           if (Result == 0) // EOF
+              ReplayFile = FileName.NextFile();
+           }
+        // Recording has been processed:
+        else {
+           IndexFileComplete = true;
+           break;
+           }
+        }
+  // Delete the index file if the recording has not been processed entirely:
+  if (IndexFileComplete)
+     Skins.QueueMessage(mtInfo, tr("Index file regeneration complete"));
+  else
+     IndexFile.Delete();
+}
+
 // --- cIndexFile ------------------------------------------------------------
 
 #define INDEXFILESUFFIX     "/index"
@@ -1343,6 +1462,9 @@
   }
   };
 
+#define MAXWAITFORINDEXFILE     10 // max. time to wait for the regenerated index file (seconds)
+#define INDEXFILECHECKINTERVAL 500 // ms between checks for existence of the regenerated index file
+
 cIndexFile::cIndexFile(const char *FileName, bool Record, bool IsPesRecording)
 :resumeFile(FileName, IsPesRecording)
 {
@@ -1352,6 +1474,7 @@
   last = -1;
   index = NULL;
   isPesRecording = IsPesRecording;
+  indexFileGenerator = NULL;
   if (FileName) {
      const char *Suffix = isPesRecording ? INDEXFILESUFFIX ".vdr" : INDEXFILESUFFIX;
      fileName = MALLOC(char, strlen(FileName) + strlen(Suffix) + 1);
@@ -1360,6 +1483,18 @@
         char *pFileExt = fileName + strlen(fileName);
         strcpy(pFileExt, Suffix);
         int delta = 0;
+        if (!Record && access(fileName, R_OK) != 0) {
+           // Index file doesn't exist, so try to regenerate it:
+           if (!isPesRecording) { // sorry, can only do this for TS recordings
+              resumeFile.Delete(); // just in case
+              indexFileGenerator = new cIndexFileGenerator(FileName);
+              // Wait until the index file exists:
+              time_t tmax = time(NULL) + MAXWAITFORINDEXFILE;
+              do {
+                 cCondWait::SleepMs(INDEXFILECHECKINTERVAL); // start with a sleep, to give it a head start
+                 } while (access(fileName, R_OK) != 0 && time(NULL) < tmax);
+              }
+           }
         if (access(fileName, R_OK) == 0) {
            struct stat buf;
            if (stat(fileName, &buf) == 0) {
@@ -1421,6 +1556,7 @@
      close(f);
   free(fileName);
   free(index);
+  delete indexFileGenerator;
 }
 
 void cIndexFile::ConvertFromPes(tIndexTs *IndexTs, int Count)
@@ -1598,6 +1734,18 @@
   return f >= 0;
 }
 
+void cIndexFile::Delete(void)
+{
+  if (fileName) {
+     dsyslog("deleting index file '%s'", fileName);
+     if (f >= 0) {
+        close(f);
+        f = -1;
+        }
+     unlink(fileName);
+     }
+}
+
 // --- cFileName -------------------------------------------------------------
 
 #define MAXFILESPERRECORDINGPES 255
diff -ruN vdr-1.7.9/recording.h vdr-1.7.10/recording.h
--- vdr-1.7.9/recording.h	2009-08-16 17:35:30.000000000 +0200
+++ vdr-1.7.10/recording.h	2009-11-21 17:12:55.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.9 2009/08/16 15:35:30 kls Exp $
+ * $Id: recording.h 2.10 2009/11/21 16:12:55 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -220,6 +220,7 @@
 #define MAXVIDEOFILESIZEDEFAULT MAXVIDEOFILESIZEPES
 
 struct tIndexTs;
+class cIndexFileGenerator;
 
 class cIndexFile {
 private:
@@ -229,6 +230,7 @@
   tIndexTs *index;
   bool isPesRecording;
   cResumeFile resumeFile;
+  cIndexFileGenerator *indexFileGenerator;
   cMutex mutex;
   void ConvertFromPes(tIndexTs *IndexTs, int Count);
   void ConvertToPes(tIndexTs *IndexTs, int Count);
@@ -245,6 +247,7 @@
   int GetResume(void) { return resumeFile.Read(); }
   bool StoreResume(int Index) { return resumeFile.Save(Index); }
   bool IsStillRecording(void);
+  void Delete(void);
   };
 
 class cFileName {
